#declare mcnt = mod(clock, 12);
#declare mcnt1 = mod(clock, 9);

#declare bug = union {

sphere { 0.0, 1 scale < 1,2,.3>*.5 // body
   texture {pigment {color <.3,.3,.35>} finish{ specular .5  ambient .5}}
   normal { crackle .75 scale .008} }

sphere { 0.0, 1 scale < 1,2,.3>*.4 translate -0.08*z // underbelly
   texture {pigment {color <.33,.33,.38>} finish{ specular .5}}
   normal {crackle .45 scale .09} }

difference {
sphere { 0.0, 1 } 
box { <-1,-1,-1> <1,1,1> translate <-1,0,1>}   
   scale < 1,2,.3>*.4 rotate <-5,0,5> translate <0.04, -0.01, .08> // left wing
   texture {pigment {radial frequency 1} finish{ specular .5}} 
}

difference {
sphere { 0.0, 1 } 
box { <-1,-1,-1> <1,1,1> translate <1,0,1>}   
   scale < 1,2,.3>*.4 rotate <-5,0,-5> translate <-0.04, -0.01, .08> // right wing
   texture {pigment {radial frequency 3} finish{ specular .5}} 
}

#declare leg = union { // leg
union {   
cylinder { 0*x 4*x 0.25}
sphere { 0.0, .25}
sphere {  4*x, .25}
}
union { // mid leg
cylinder { 0*x 3*x  0.2}
sphere { 0*x, .2}
sphere {  3*x, .2}
rotate 45*y translate 4*x
}
union { //bot leg
cylinder { 0*x 2*x 0.15}
sphere { 0*x, .15}
sphere {  2*x, .15}
rotate 90*y translate (4+(3/1.414))*x translate -(3/1.414)*z 
}
   texture {pigment {color <.4,.45,.4>} finish{ specular 1  ambient .5} 
   normal {crackle -1 scale .001} }
   scale <.225 ,.15,.15>       
}

#if (walk=0)
object { leg rotate 30*z rotate -0*y translate <0.1, 0, -0.2> translate .2*y }
object { leg rotate 150*z rotate 0*x translate <-0.1, 0, -0.2> translate .2*y }
object { leg rotate 0*z translate <0.1, 0, -0.2> }
object { leg rotate 180*z translate <-0.1, 0, -0.2> }
object { leg rotate -30*z translate <0.1, 0, -0.2> translate -.2*y }
object { leg rotate 210*z rotate 0*x translate <-0.1, 0, -0.2> translate -.2*y }
#end

#if (walk=1)
// six legs
//-----------FRONT
// left front decrease 30 to 0 is forward
#if (mcnt=0) object { leg rotate 30*z rotate -0*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=1) object { leg rotate 25*z rotate -3*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=2) object { leg rotate 20*z rotate -6*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=3) object { leg rotate 15*z rotate -8*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=4) object { leg rotate 10*z rotate -6*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=5) object { leg rotate 05*z rotate -3*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=6) object { leg rotate 00*z rotate -0*y translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=7) object { leg rotate 05*z translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=8) object { leg rotate 10*z translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=9) object { leg rotate 15*z translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=10) object { leg rotate 20*z translate <0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=11) object { leg rotate 25*z translate <0.1, 0, -0.2> translate .2*y }#end

// right front decrease is forward
//object { leg rotate 150*z rotate 0*x translate <-0.1, 0, -0.2> translate .2*y }//stop position
#if (mcnt=0) object { leg rotate 180*z translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=1) object { leg rotate 175*z translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=2) object { leg rotate 170*z translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=3) object { leg rotate 165*z translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=4) object { leg rotate 160*z translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=5) object { leg rotate 155*z rotate -0*y translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=6) object { leg rotate 150*z rotate -3*y translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=7) object { leg rotate 155*z rotate -6*y translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=8) object { leg rotate 160*z rotate -8*y translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=9) object { leg rotate 165*z rotate -6*y translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=10) object { leg rotate 170*z rotate -3*y translate <-0.1, 0, -0.2> translate .2*y }#end
#if (mcnt=11) object { leg rotate 175*z rotate -0*y translate <-0.1, 0, -0.2> translate .2*y }#end

//-----------CENTER
//left center increase is forward
//object { leg rotate 0*z translate <0.1, 0, -0.2> }//stop position
#if (mcnt=0) object { leg rotate 0*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=1) object { leg rotate 5*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=2) object { leg rotate 10*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=3) object { leg rotate 15*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=4) object { leg rotate 10*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=5) object { leg rotate 5*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=6) object { leg rotate 0*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=7) object { leg rotate -5*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=8) object { leg rotate -10*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=9) object { leg rotate -15*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=10) object { leg rotate -10*z translate <0.1, 0, -0.2>  }#end
#if (mcnt=11) object { leg rotate -5*z translate <0.1, 0, -0.2>  }#end

// right center decrease is forward 
//object { leg rotate 180*z translate <-0.1, 0, -0.2> }//stop position
#if (mcnt=0) object { leg rotate 180*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=1) object { leg rotate 185*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=2) object { leg rotate 190*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=3) object { leg rotate 195*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=4) object { leg rotate 190*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=5) object { leg rotate 185*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=6) object { leg rotate 180*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=7) object { leg rotate 175*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=8) object { leg rotate 170*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=9) object { leg rotate 165*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=10) object { leg rotate 170*z translate <-0.1, 0, -0.2>  }#end
#if (mcnt=11) object { leg rotate 175*z translate <-0.1, 0, -0.2>  }#end

//-----------REAR
// left rear decrease -30 to 0 is forward
//object { leg rotate -30*z translate <0.1, 0, -0.2> translate -.2*y }// stop position
#if (mcnt=0) object { leg rotate 0*z translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=1) object { leg rotate -5*z translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=2) object { leg rotate -10*z translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=3) object { leg rotate -15*z translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=4) object { leg rotate -20*z translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=5) object { leg rotate -25*z rotate -0*y translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=6) object { leg rotate -30*z rotate -3*y translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=7) object { leg rotate -25*z rotate -6*y translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=8) object { leg rotate -20*z rotate -8*y translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=9) object { leg rotate -15*z rotate -6*y translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=10) object { leg rotate -10*z rotate -3*y translate <0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=11) object { leg rotate -5*z rotate -0*y translate <0.1, 0, -0.2> translate -.2*y }#end
// right rear decrease is forward
//object { leg rotate 210*z rotate 0*x translate <-0.1, 0, -0.2> translate -.2*y }//stop position
#if (mcnt=0) object { leg rotate 210*z rotate -0*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=1) object { leg rotate 205*z rotate -3*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=2) object { leg rotate 200*z rotate -6*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=3) object { leg rotate 195*z rotate -8*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=4) object { leg rotate 190*z rotate -6*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=5) object { leg rotate 185*z rotate -3*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=6) object { leg rotate 180*z rotate -0*y translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=7) object { leg rotate 185*z translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=8) object { leg rotate 190*z translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=9) object { leg rotate 195*z translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=10) object { leg rotate 200*z translate <-0.1, 0, -0.2> translate -.2*y }#end
#if (mcnt=11) object { leg rotate 205*z translate <-0.1, 0, -0.2> translate -.2*y }#end
// end legs 
#end
   
#declare head = union {
sphere { 0.0, 1 scale < 1,2, .5>*.2 rotate<0,90,90> translate <0,1,0> //head
   texture {pigment {color <.25,.25,.3>} finish{ specular 1 ambient .5} 
   normal {crackle 1 scale .04}} }

sphere { 0.0, 1 scale < 1,1, 1>*.1 translate <.2, 1.06, 0> //right eye
   texture {pigment {hexagon pigment {color rgb<0,0,0> }
                             pigment {color rgb<0,1,0>}
                             pigment {color rgb<1,1,0>} } finish { specular 1
                                                               ambient .5} 
                                   rotate -30*x scale .0035 } }

sphere { 0.0, 1 scale < 1,1, 1>*.1 translate <-.2,1.06,0> //left eye
   texture {pigment {hexagon pigment {color <0,0,0> }
                             pigment {color <0,1,0>}
                             pigment {color <1,1,0>} } finish { specular 1
                                                               ambient .5} 
                                    rotate -30*x scale .0035 } }

sphere { 0.0, 1 scale < 1,1.1, .3>*.075 rotate 90*x translate <0,1.0,-0.2> //mouth
   texture {pigment {color <.5,.5,.6>} finish{ specular .75 ambient .5} }
   normal { crackle 1 scale .02} }

sphere { 0.0, 1 scale < 1, 1.2, .3>*.075 rotate 90*x translate <-0.05, 1.0, -0.2> //mouth
   texture {pigment {color <.4,.4,.5>} finish{ specular 1 ambient .5}}
   normal {crackle -.5 scale .01} }

sphere { 0.0, 1 scale < 1, 1.2, .3>*.075 rotate 90*x translate <0.05, 1.0, -0.2> //mouth
   texture {pigment {color <.4,.4,.5>} finish{ specular 1 ambient .5}} 
   normal {crackle -.5 scale .01}}

#declare c = 1;
#while (c<50)

sphere { 0.0, 1 scale < 1,1.5, 1>*.013 
//            translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/45)> //right antenna
#if (mcnt1=0) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+0))> #end
#if (mcnt1=1) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+3))> #end
#if (mcnt1=2) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+6))> #end
#if (mcnt1=3) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+9))> #end
#if (mcnt1=4) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+12))> #end
#if (mcnt1=5) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+9))> #end
#if (mcnt1=6) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+6))> #end
#if (mcnt1=7) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+3))> #end
#if (mcnt1=8) translate <.22+(c/150), 1+(c/100),0.125+(c/300)*cos(c/(45+1))> #end


   texture {pigment {color <.3,.31,.3>} finish{ specular 1 ambient .5}} }

sphere { 0.0, 1 scale < 1,1.5, 1>*.013 
//            translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/40)> //left antenna
#if (mcnt1=0) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+12))> #end
#if (mcnt1=1) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+9))> #end
#if (mcnt1=2) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+6))> #end
#if (mcnt1=3) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+3))> #end
#if (mcnt1=4) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+0))> #end
#if (mcnt1=5) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+3))> #end
#if (mcnt1=6) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+6))> #end
#if (mcnt1=7) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+9))> #end
#if (mcnt1=8) translate <-.22-(c/200), 1+(c/100),0.125+(c/100)*cos(c/(40+11))> #end
   texture {pigment {color <.31,.31,.3>} finish{ specular 1 ambient .5}} }

#declare c = c+1;
#end
}

// for animating the head back to zero, move, put back 
object { head translate <0, -1, 0> 
#if (mcnt=0) rotate<0,0,0> #end
#if (mcnt=1) rotate<0,0,4> #end
#if (mcnt=2) rotate<0,0,8> #end
#if (mcnt=3) rotate<0,0,4> #end
#if (mcnt=4) rotate<0,0,2> #end
#if (mcnt=5) rotate<0,0,0> #end
#if (mcnt=6) rotate<0,0,-2> #end
#if (mcnt=7) rotate<0,0,-4> #end
#if (mcnt=8) rotate<0,0,-8> #end
#if (mcnt=9) rotate<0,0,-4> #end
#if (mcnt=10) rotate<0,0,-2> #end
#if (mcnt=11) rotate<0,0,0> #end

rotate -10*x rotate 1*y rotate 0*z translate <0, 1, 0>}

} // end bug union
